# Slack

This is a PCMRBot.js module that facilitates communication with the Slack API.

There is no suggested limit to the number of instances of this model you can run, but if you have multiple hosts hosting the actions/events APIs, you will need to run a load balancer in front of them to spread the load properly.

## Dependencies

This module has no dependencies. 

## Environment variables

The following environment variables should be set prior to launch. 

* Module options
  * `SLACK_TOKEN` - The TOTP token assigned by Slack for your application
  * (optional) `SLACK_DEFAULTCHANNEL` - The default channel to post to if no channel is supplied
  * (optional) `SLACK_USE_ACTIONS_API` - Whether a server for the Actions API should be launched. Defaults to false
  * (optional) `SLACK_USE_EVENTS_API` - Whether a server for the Events API should be launched. Defaults to false
  * (optional) `SLACK_ACTIONS_PORT` - The port to use for the Actions API server. Not required if server is not enabled
  * (optional) `SLACK_EVENTS_PORT` - The port to use for the Events API server. Not required if server is not enabled
  * (optional) `SLACK_ACTIONS_HOST` - The hostname of the machine the Actions API server is running on. Used for proxy/load balancing configuration
  * (optional) `SLACK_EVENTS_HOST` - The hostname of the machine the Events API server is running on. Used for proxy/load balancing configuration
  * (optional) `SLACK_VERIFICATION_TOKEN` - The Actions API verification token. Not required if the Actions API is not enabled
* Broker options
  * (optional) `TRANSPORT_NODE_ID` - The node ID that should be used for connecting to the rest of the cluster. Defaults to the system hostname plus a random number string. 
  * (optional) `TRANSPORT_BIND_ADDRESS` - The network address that the service broker should bind to. Defaults to all available addresses across all network interfaces.

# API Reference

{{>main}}